using System;
using System.Linq;
using System.Text;
using System.Net.NetworkInformation;
namespace PHS
{
    public partial class Methods
    {
        private static string MacAddresses
        {
            get // Get the MAC addresses for all devices whose operational status is up.
            {
                StringBuilder sb = new StringBuilder();
                foreach(string pa in from ni in NetworkInterface.GetAllNetworkInterfaces() where ni.OperationalStatus == OperationalStatus.Up select ni.GetPhysicalAddress().ToString().Trim())
                {
                    sb.Append(string.IsNullOrEmpty(pa) || pa.Length == 0 ? "UNKNOWN" : pa);
                    sb.Append("|");
                }
                string x = sb.ToString();
                int last = x.Length - 1;
                return x.Substring(0, last);
            }
        }

        private static Selection DisplaySelectionForm(string variable)
        {
            SelectionForm form = new SelectionForm(variable);
            form.ShowDialog();
            Selection s = new Selection();
            s.Cancelled = form.Cancelled;
            s.VariableName = form.VariableName;
            return s;
        }

        private static void DeconstructState(string statement, out string variable)
        {
            if(string.IsNullOrEmpty(statement)) // The statement cannot be null.
            {
                variable = string.Empty;
                return;
            }

            // Locate the position of the "variable" keyword. Everything that follows is trimmed and returned as the name of the variable.

            int i = statement.IndexOf("variable", StringComparison.InvariantCulture);
            variable = statement.Substring(i + 8).Trim();
        }

        private static string ConstructStatement(string variable)
        {
            // When constructing the statement we return back to IA we only return the variable name containing the MAC addresses.

            return string.Format("into variable {0}", variable);
        }
    }
}
